#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#define DS_PORT    PORTD
#define DS_PIN     0
#define ST_CP_PORT PORTD
#define ST_CP_PIN  1
#define SH_CP_PORT PORTD
#define SH_CP_PIN  4
 
#define DS_low()  DS_PORT&=~_BV(DS_PIN)
#define DS_high() DS_PORT|=_BV(DS_PIN)
#define ST_CP_low()  ST_CP_PORT&=~_BV(ST_CP_PIN)
#define ST_CP_high() ST_CP_PORT|=_BV(ST_CP_PIN)
#define SH_CP_low()  SH_CP_PORT&=~_BV(SH_CP_PIN)
#define SH_CP_high() SH_CP_PORT|=_BV(SH_CP_PIN)
 
//Define functions
//======================
void ioinit(void);
void output_led_state(unsigned char __led_state[32]);
//======================
 

 
int main (void){

	ioinit(); //Setup IO pins and defaults
	unsigned char leds0[32] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	unsigned char leds1[32] = {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};
 
	while(1){
		output_led_state(leds1);
		_delay_ms(10); 
		output_led_state(leds0);
		_delay_ms(100);
   }
}
 
 
void ioinit (void){
    DDRD  = 0b10010011; //1 = output, 0 = input
    PORTD = 0b00000000;
}

// functie pt shiftare a bitilor pentru cele 32 de leduri 
void output_led_state(unsigned char __led_state[32]){	
	int j;
	SH_CP_low();
	ST_CP_low();
	for (j = 0; j < 32; ++j){
	  
		if (__led_state[j])
			DS_low();
		else  
			DS_high();
	 
 
		SH_CP_high();
		SH_CP_low();
	}
	
	ST_CP_high();
}